%{!?tcl_version: %define tcl_version %(echo 'puts $tcl_version' | tclsh)}
%{!?tcl_sitelib: %define tcl_sitelib %{_datadir}/tcl%{tcl_version}}
%{!?tcl_sitearch: %define tcl_sitearch %{_libdir}/tcl%{tcl_version}}

Summary: TclDOM is a package that provides a DOM binding for the Tcl scripting language
Name: tcldom
Version: 3.1
Release: 12%{?dist}
License: BSD
Group: Development/Libraries
URL:   http://tclxml.sourceforge.net/
Source0: http://downloads.sourceforge.net/tclxml/tcldom-3.1.tar.gz
Source1: pkgIndex.tcl.in.gui
Patch0: tcldom.patch
Patch1: tcldom-3.1-pkgprovides.patch
Patch2: tcldom-3.1-cversion.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: tcl-devel libxml2-devel tclxml-devel expat-devel
Requires: tcl(abi) = 8.5 tclxml tcllib

%description
This package provides a DOM binding for Tcl.  It provides one of the following
implementations:
    *     A Tcl-only implementation (slow, but no compilation required),
    *     A wrapper for the Gnome libxml2 library [http://xmlsoft.org/]
          (also fast and compatiable with TclXSLT/libxslt
          [http://tclxml.sourceforge.net/tclxslt.html]).

%package expat
Summary: The Tcl dom parser built with the expat xml parser
Group: Development/Libraries
Requires: %{name} = %{version}-%{release} tclxml-expat
%description expat
This package provides an optimized Tcl dom parser built with the expat
xml parser.

%package libxml2
Summary: The Tcl dom parser built with the libxml2 xml parser
Group: Development/Libraries
Requires: %{name} = %{version}-%{release} tclxml-libxml2
%description libxml2
This package provides an optimized Tcl dom parser built with the libxml2
xml parser.

%package gui
Summary: UI widgets for manipulating a DOM tree
Group: Development/Libraries
Requires: %{name} = %{version}-%{release} bwidget
%description gui
This package provides some useful widgets for manipulating a DOM tree.

%package devel
Summary: The Tcl dom parser development files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release} tclxml-devel
Requires: %{name}-libxml2 = %{version}-%{release} tclxml-devel
%description devel
Development headers and libraries needed to link new applications against
tcldom.

%prep
%setup -q
touch -r src/configure.in src/configure.in.stamp
touch -r src-libxml2/configure.in src-libxml2/configure.in.stamp
%patch0 -p1
%patch1
%patch2
touch -r src/configure.in.stamp src/configure.in
touch -r src-libxml2/configure.in.stamp src-libxml2/configure.in
%{__sed} -i 's/\r//' examples/tkxmllint.tcl

%build
pushd src
%configure --enable-threads
make %{?_smp_mflags}
popd
pushd src-libxml2
%configure --enable-threads
make %{?_smp_mflags}
popd

%install
rm -rf $RPM_BUILD_ROOT
# We have to hand-install the base Tcl files since the configure script
# doesn't take care of that.
mkdir -p $RPM_BUILD_ROOT/%{tcl_sitelib}/%{name}%{version}
install -m 0644 library/*.tcl $RPM_BUILD_ROOT/%{tcl_sitelib}/%{name}%{version}
sed -e 's/@VERSION@/%{version}/' < library/pkgIndex.tcl.in > $RPM_BUILD_ROOT/%{tcl_sitelib}/%{name}%{version}/pkgIndex.tcl

pushd src-libxml2
mkdir -p $RPM_BUILD_ROOT%{tcl_sitearch}
make install DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_libdir}/tcldom_libxml23.1 $RPM_BUILD_ROOT%{tcl_sitearch}/%{name}_libxml2-%{version}
popd

pushd src
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{tcl_sitearch}
mv $RPM_BUILD_ROOT%{_libdir}/tcldom3.1 $RPM_BUILD_ROOT%{tcl_sitearch}/%{name}_expat-%{version}
popd

# Install the examples in a -gui subpackage
install -d $RPM_BUILD_ROOT%{tcl_sitelib}/%{name}-gui%{version}
sed -e 's/@VERSION@/%{version}/' < %{SOURCE1} > $RPM_BUILD_ROOT/%{tcl_sitelib}/%{name}-gui%{version}/pkgIndex.tcl
install -p -m 0644 examples/domtree.tcl \
        examples/domtree-treectrl.tcl \
        examples/domtext.tcl \
        examples/cgi2dom.tcl \
        $RPM_BUILD_ROOT%{tcl_sitelib}/%{name}-gui%{version}/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{tcl_sitelib}/%{name}%{version}
%doc ChangeLog README MANIFEST RELNOTES LICENSE
%doc docs/* examples/*

%files expat
%defattr(-,root,root)
%dir %{tcl_sitearch}/%{name}_expat-%{version}
%{tcl_sitearch}/%{name}_expat-%{version}/*.tcl
%{tcl_sitearch}/%{name}_expat-%{version}/*.so

%files libxml2
%defattr(-,root,root)
%dir %{tcl_sitearch}/%{name}_libxml2-%{version}
%{tcl_sitearch}/%{name}_libxml2-%{version}/*.tcl
%{tcl_sitearch}/%{name}_libxml2-%{version}/*.so

%files gui
%defattr(-,root,root)
%dir %{tcl_sitelib}/%{name}-gui%{version}
%{tcl_sitelib}/%{name}-gui%{version}/*.tcl

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/%{name}libxml2Config.sh
%{tcl_sitearch}/%{name}_libxml2-%{version}/*.a

%changelog
* Sat Feb 8 2008 Wart <wart at kobold.org> - 3.1-12
- Rebuild for gcc 4.3

* Thu Jan 3 2008 Wart <wart at kobold.org> - 3.1-11
- Rebuild for Tcl 8.5
- Better download URL

* Fri Apr 13 2007 Wart <wart at kobold.org> - 3.1-10
- Fix BuildRequires: for directory ownership in -devel subpackage

* Fri Feb 16 2007 Wart <wart at kobold.org> - 3.1-9
- Rebuild for reversion to tcl8.4

* Thu Feb 8 2007 Wart <wart at kobold.org> - 3.1-8
- Add missing BuildRequires: tcl

* Thu Feb 8 2007 Wart <wart at kobold.org> - 3.1-7
- Add a -gui subpackage for the dom-based widgets
- Add a -expat subpackage for the expat-based dom parser

* Mon Aug 28 2006 Wart <wart at kobold.org> - 3.1-6
- Rebuild for Fedora Extras

* Thu Jun 1 2006 Wart <wart at kobold.org> - 3.1-5
- Fixed Requires: for subpackages

* Wed Feb 22 2006 Wart <wart at kobold.org> - 3.1-4
- Rebuild for FC5

* Wed Jan 11 2006 Wart <wart at kobold.org> - 3.1-3
- Fix quoting bug that is exposed by bash >= 3.1

* Tue Dec 13 2005 Wart <wart at kobold.org> - 3.1-2
- Update patch to fix version numbers that weren't updated upstream

* Sun Nov 27 2005 Wart <wart at kobold.org> - 3.1-1
- Update to new upstream sources.

* Sat Nov 26 2005 Wart <wart at kobold.org> - 3.0-2
- Minor spec file changes to remove rpmlint warnings

* Fri Jun 17 2005 Wart <wart at kobold.org> - 3.0-1
- New spec file to conform to Fedora Core 4 standards.
